(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["appSdk"] = factory();
	else
		root["appSdk"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 2);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.wrapperNativeName = wrapperNativeName;
exports.safeFunction = safeFunction;
exports.required = required;
/**
 * 在调用invoke方法时，方法名加入后缀，用于直接映射native方法。
 * @param name
 * @returns {string}
 */
function wrapperNativeName(name) {
  return name + ":callback:";
}

/**
 * 保证返回一个Function
 * @param callback
 * @returns {Function}
 */
function safeFunction(callback) {
  return callback || function () {};
}

/**
 * 做参数的必填验证
 * @param debug
 * @param requireObj
 * @param fnName
 * @returns {boolean}
 */
function required() {
  var debug = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  var requireObj = arguments[1];
  var fnName = arguments[2];

  if (!requireObj) {
    return true;
  }
  var keys = Object.keys(requireObj);
  for (var i = 0; i < keys.length; i++) {
    if (!requireObj[keys[i]] && debug && fnName) {
      console.log(fnName + "\u4E2D\u53C2\u6570 " + keys[i] + " \u5FC5\u987B\u586B\u5199!");
      return false;
    }
  }

  return true;
}

exports.default = {
  wrapperNativeName: wrapperNativeName,
  safeFunction: safeFunction,
  required: required
};

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(3);


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _deviceEnv = __webpack_require__(4);

// 根据不同环境获取不同 sdk api
var appSdk = _deviceEnv.isApp ? __webpack_require__(5).default : __webpack_require__(6).default;

exports.default = appSdk;

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var win = window;
var ua = win.navigator.userAgent;

// 各种设备判断，后续根据需要再加入
var isWx = exports.isWx = ua.search(/micromessenger/ig) !== -1; // 微信
var isIos = exports.isIos = ua.indexOf('iPhone') !== -1 || ua.indexOf('iPad') !== -1; // ios 系统
var isAndroid = exports.isAndroid = ua.indexOf('Android') !== -1; // Android 系统
var isJdApp = exports.isJdApp = ua.indexOf('jdapp') !== -1; // 京东 app
var isDlApp = exports.isDlApp = /zxyh_dalianbank/i.test(ua); // 大连银行
var isZxyh = exports.isZxyh = /zxyh/i.test(ua); // 直销银行银行
// TODO 我们用 isZxyh 来判断是在 app 中，后续根据需要增加判断条件
var isApp = exports.isApp = isZxyh;
var isMobile = exports.isMobile = isIos || isAndroid; // 手机端
var isPc = exports.isPc = !isMobile; // pc 端

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(process) {

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sdk = undefined;

var _tools = __webpack_require__(1);

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var win = window;
var doc = document;

// 用 Promise 包裹 sdk
var sdk = exports.sdk = new Promise(function (resolve, reject) {
  if (win.platform) {
    resolve(win.platform);
  } else {
    // 添加 sdk 监听事件
    doc.addEventListener('platformReady', function () {
      if (typeof win.platform === 'undefined' || !win.platform) {
        console.log('未获取到 sdk!');
        reject(new Error('未获取到 sdk!'));
      } else {
        resolve(win.platform);
      }
    }, false);
  }
});

/**
 * 平台对外暴露的接口及事件对象
 * @class appSdk
 * {@link http://wiki.cbpmgt.com/confluence/pages/viewpage.action?pageId=19693404 WIKI}
 * demo: http://172.25.47.49/hybrid/demo/platform.html platformDemo
 * http://wiki.cbpmgt.com/confluence/pages/viewpage.action?pageId=20402153
 */

/**
 * 1 env
 * 2 setTitle
 * 3 setTitleBarVisible
 * 4 setMenu
 * 5 getCommonInfo
 * 6 getUserInfo
 * 7 request
 * 8 toast
 * 9 confirm
 * 10 close
 * 11 start
 * 12 checkNetwork
 * 13 share
 * 14 buryPageStart
 * 15 buryPageEnd
 * 16 buryEvent
 * 17 checkLoginStatus
 * 18 putCache
 * 19 getCache
 * 20 removeCache
 * 以下为事件监听
 * 21 onBackPress
 * 22 onClose
 * 23 onLogout
 * 24 onNetChanged
 * 25 onBackground
 * 26 onForeground
 * 27 onShake
 * 28 onPush
 * 直销银行App额外方法
 * 29 getAppCommonInfo
 * 30 appRequest
 * 31 showTradePasswordInput
 * 32 authOutOfDate
 * 33 showResultCtrlDialog
 */
var appSdk = {

  debug: process.env.NODE_ENV === 'development', // 是否启用调试,再调试模式下参数检查情况会输出到控制台

  /**
   * 设置
   * @param debug
   */
  setDebug: function setDebug(debug) {
    this.debug = debug;
  },


  /*eslint-disable max-len*/
  /**
   * 获取platform协议的实现情况，比如可用的事件、可用的接口、协议版本等
   * @param callback
   * 返回的结果
   {
      code: 0,
      data: '*appRequest*authOutOfDate*buryEvent*buryPageEnd*buryPageStart*checkLoginStatus*checkNetwork*close*confirm*getAppCommonInfo*getCache*getCommonInfo*getPayLimit*onEvent*putCache*removeCache*request*setMenu*setTitle*setTitleBarVisible*showResultCtrlDialog*showTradePasswordInput*toast',
      time: '1505728066354'
    }
   */
  env: function env(callback) {
    // 1
    return sdk.then(function (platform) {
      platform.env(callback);
    });
  },


  /**
   * 设置浏览器标题
   * app默认使用页面title字段,手动调用此api会覆盖原有title
   * 只对当前页面有效
   * @param param {Object}
   * * 参数格式
   {
      titleName: '', // String no 标题名称
      titleColor: '', // String no 标题颜色 标准色值比如 #FFFFFF
      titleBackgroundColor: '', //  String no 标题颜色 标准色值比如 #FFFFFF
      subTitleName: '', //  String no 子标题名称
      subTitleColor: '', //  String no 子标题颜色 标准色值比如 #FFFFFF
      titleDivider: '', //  String no  标题下方分割线显示：visible 隐藏：hide 不传：保持不变。 默认显示分割线
      backTitleColor: '', //  String no 返回按钮的颜色 标准色值比如 #FFFFFF
      closeTitleColor: '', //  String no 关闭按钮的颜色 标准色值比如 #FFFFFF
   }
   *
   */
  setTitle: function setTitle(param) {
    // 2
    if ((0, _tools.required)(this.debug, {
      param: param
    }, 'setTitle')) {

      return sdk.then(function (platform) {
        platform.invoke((0, _tools.wrapperNativeName)('setTitle'), param);
      });
    }
  },


  /**
   * 设置标题栏的显示/隐藏
   * @param visible {boolean}
   */
  setTitleBarVisible: function setTitleBarVisible() {
    var visible = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    // 3
    return sdk.then(function (platform) {
      platform.invoke((0, _tools.wrapperNativeName)('setTitleBarVisible'), { visible: visible });
    });
  },


  /**
   * 设置当前页面头部右侧菜单
   * 单个直接显示在右侧，多个的话以下拉的形式显示
   * 目前实现：Android 当路由切换后会自动去掉右侧菜单
   * 但 IOS 需要手动清除掉右侧菜单，传入空数组即可
   * @param menus {Array}
   * 参数格式
   [{
      menuTitle: "扫一扫",
      menuImage: "http://localhost:8080/sao.png",
      menuAction: "function"
   }]
   *
   */
  setMenu: function setMenu() {
    var menus = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    // 4
    if (!Array.isArray(menus)) {
      if (this.debug) {
        console.log('setMenu, menus 必须是一个数组类型');
      }
      return;
    }
    for (var l = menus.length; l > 0; l--) {
      var _required;

      var _menu = menus[l - 1];
      if (!(0, _tools.required)(this.debug, (_required = {}, _defineProperty(_required, 'menus[' + l + '].menuTitle', _menu.menuTitle), _defineProperty(_required, 'menus[' + l + '].menuAction', _menu.menuAction), _required), 'setMenu')) {
        return;
      }
    }

    menus.forEach(function (it) {
      it.menuAction = (0, _tools.safeFunction)(it.menuAction);
    });

    return sdk.then(function (platform) {
      platform.invoke((0, _tools.wrapperNativeName)('setMenu'), { menus: menus });
    });
  },


  /**
   * 获取公共参数信息
   * @param callback {function}
   * 返回的数据格式为
   * 注意：data 中的值是字符串 json 数据，需要使用 JSON.parse(data) 解析处理
   {
    code: 0,
    time: 1505199918343,
    data: {
      appVersion: 'app 版本',
      channel: '渠道标识',
      clientName: '设备（ios，android',
      deviceId: '设备唯一标识',
      deviceType: '设备类型',
      mac: 'mac地址',
      osVersion: ''
    }
   }
   */
  getCommonInfo: function getCommonInfo(callback) {
    // 5
    if ((0, _tools.required)(this.debug, { callback: callback }, 'getCommonInfo')) {
      return sdk.then(function (platform) {
        platform.invoke((0, _tools.wrapperNativeName)('getCommonInfo'), {}, (0, _tools.safeFunction)(callback));
      });
    }
  },


  /**
   * 获取当前用户的基本信息
   * @param callback {function}
   * 返回的数据格式为
   * 注意：data 中的值是字符串 json 数据，需要使用 JSON.parse(data) 解析处理
   {
    code: 0,
    time: 1505199918343,
    data: {
      channelUserId: '渠道用户标识',
      hasOpenSecAccount: '是否已开通二类户'
    }
   }
   */
  getUserInfo: function getUserInfo(callback) {
    // 6
    if ((0, _tools.required)(this.debug, { callback: callback }, 'getUserInfo')) {
      return sdk.then(function (platform) {
        platform.invoke((0, _tools.wrapperNativeName)('getUserInfo'), {}, (0, _tools.safeFunction)(callback));
      });
    }
  },


  /**
   * 网络请求
   * @param param {{}}
   * param 格式
   {
    url: '请求url地址',
    httpMethod: 'GET 或 POST DELETE 等', // 注意是大写
    parameters: 'json 字符串' // JSON.stringify(json)
   }
   * @param callback {function}
   */
  request: function request(param, callback) {
    // 7
    if ((0, _tools.required)(this.debug, {
      param: param,
      'param.url': param && param.url,
      'param.httpMethod': param && param.httpMethod,
      'param.parameters': param && param.parameters,
      callback: callback
    }, 'request')) {

      return sdk.then(function (platform) {
        platform.invoke((0, _tools.wrapperNativeName)('request'), param, (0, _tools.safeFunction)(callback));
      });
    }
  },


  /**
   * 弹出toast
   * @param param {{}} { msg(必填):String }
   */
  toast: function toast(param) {
    // 8
    if ((0, _tools.required)(this.debug, { param: param, 'param.msg': param && param.msg }, 'toast')) {
      return sdk.then(function (platform) {
        platform.invoke((0, _tools.wrapperNativeName)('toast'), param);
      });
    }
  },


  /**
   * 确认提示框
   * @param param {{}} { title(必填):String, msg(必填):String, cancelBtnText:String, cancelCallBack:function, okBtnText:String, okCallBack:function }
   */
  confirm: function confirm(param) {
    // 9
    if ((0, _tools.required)(this.debug, {
      param: param,
      'param.title': param && param.title,
      'param.msg': param && param.msg
    }, 'confirm')) {

      return sdk.then(function (platform) {
        platform.invoke((0, _tools.wrapperNativeName)('confirm'), param);
      });
    }
  },


  /**
   * 关闭浏览器
   */
  close: function close() {
    // 10
    return sdk.then(function (platform) {
      platform.invoke((0, _tools.wrapperNativeName)('close'), {});
    });
  },


  /**
   * 启动app模块，目前实现的模块有：登录：LOGIN（如果当前是登录态，则不会跳到登录页面，只会回调 callback）开户：OPENACCOUNT
   * @param param {{}}
   * @param callback {function}
   * 回调结果根据具体的模块返回不同的数据
   * name是LOGIN的情况下：返回值和 getUserInfo 返回值相同
   */
  start: function start(param, callback) {
    // 11
    if ((0, _tools.required)(this.debug, {
      param: param,
      'param.name': param && param.name,
      'param.param': param && param.param
    }, 'start')) {

      param.param = JSON.stringify(param.param);

      return sdk.then(function (platform) {
        platform.invoke((0, _tools.wrapperNativeName)('start'), param, (0, _tools.safeFunction)(callback));
      });
    }
  },


  /**
   * 检查设备的网络状况
   *
   * @param callback {function} 回调参数 : { hasNetwork:boolean, netType:String(wifi|2G|3G|4G|unknow) }
   */
  checkNetwork: function checkNetwork(callback) {
    // 12
    if ((0, _tools.required)(this.debug, { callback: callback }, 'checkNetwork')) {

      return sdk.then(function (platform) {
        platform.invoke((0, _tools.wrapperNativeName)('checkNetwork'), {}, function (resp) {
          if (resp && resp.code === 0 && resp.data) {
            resp.data.hasNetwork = Boolean(resp.data.hasNetwork);
          }
          callback(resp);
        });
      });
    }
  },


  /**
   * 调用app的分享功能
   * @param param {{}} { type(必填): String[text|web|view], channel(必填): String[WX|QQ|WB|MON|STOCK] }
   * * 参数格式
   {
      channel: 'WX|WB|QQ|MON|STOCK', // 分享渠道， WX|WB|QQ|MON|STOCK 中间用竖线隔开，可选其中某个或某几个， 空串的话默认为全部。WX代表微信好友和微信朋友圈
      url: '', // Web分享地址
      title: '', //  Web分享标题
      desc: '', //  Web分享描述
      text: '', //  文本分享内容
      iconUrl: '', //  Web分享图标
      startY: '', //  截图起始 0-1的值 页面比例
      endY: '', //  截图尾部 0-1的值 页面比例
      type: '', // 分享类型（text, view, web）(类型为text时，text必填类型，为view时，startY和endY必填类型，为web时，url必填)
   }
   Fixme 目前该功能，手机端实现有问题
   * @param callback {function}
   */
  share: function share(param, callback) {
    // 13
    if ((0, _tools.required)(this.debug, {
      param: param,
      'param.type': param && param.type,
      'param.channel': param && param.channel
    }, 'share')) {

      if (['text', 'web', 'view'].indexOf(param.type) === -1) {
        if (this.debug) {
          console.log('不正确的分享类型:', param.type);
        }
        return;
      }

      var channels = param.channel.split('|'),
          expectChannel = ['WX', 'QQ', 'WB', 'MON', 'STOCK'];
      for (var l = channels.length; l > 0; l--) {
        if (expectChannel.indexOf(channels[l - 1]) === -1) {
          if (this.debug) {
            console.log('不正确的分享渠道:', param.channel);
          }
          return;
        }
      }

      return sdk.then(function (platform) {
        platform.invoke((0, _tools.wrapperNativeName)('share'), param, (0, _tools.safeFunction)(callback));
      });
    }
  },


  /**
   * 进入页面埋点
   * @param param {page: 'page1'} 页面名称 (同一页面的页面名称应和 buryPageEnd 中的页面名称相同)
   * @returns {Promise.<TResult>}
   */
  buryPageStart: function buryPageStart(param) {
    // 14
    if ((0, _tools.required)(this.debug, {
      param: param
    }, 'buryPageStart')) {

      return sdk.then(function (platform) {
        platform.on((0, _tools.wrapperNativeName)('buryPageStart'), param);
      });
    }
  },


  /**
   * 离开页面埋点
   * @param param {page: 'page1'} 页面名称 (同一页面的页面名称应和 buryPageStart 中的页面名称相同)
   * @returns {Promise.<TResult>}
   */
  buryPageEnd: function buryPageEnd(param) {
    // 15
    if ((0, _tools.required)(this.debug, {
      param: param
    }, 'buryPageEnd')) {

      return sdk.then(function (platform) {
        platform.on((0, _tools.wrapperNativeName)('buryPageEnd'), param);
      });
    }
  },


  /**
   * 埋点事件
   * @param param {}
   * 传参格式
   {
     eventID: '', //事件ID
     properties: {} // 事件属性
   }
   * @returns {Promise.<TResult>}
   */
  buryEvent: function buryEvent(param) {
    // 16
    if ((0, _tools.required)(this.debug, {
      param: param
    }, 'buryEvent')) {

      return sdk.then(function (platform) {
        platform.on((0, _tools.wrapperNativeName)('buryEvent'), param);
      });
    }
  },


  /**
   * 检查是否是登录状态
   * @param callback
   * 返回结果
   {
     code: 0,
     data: {
      isLogin: true // 是否为登录态
     },
     time: ''
   }
   * @returns {Promise.<TResult>}
   */
  checkLoginStatus: function checkLoginStatus(callback) {
    // 17
    return sdk.then(function (platform) {
      platform.invoke((0, _tools.wrapperNativeName)('checkLoginStatus'), {}, (0, _tools.safeFunction)(callback));
    });
  },


  /**
   * 放入本地缓存,考虑缓冲区已满的问题
   * @param {string} type local|session
   * @param key {String}
   * @param value {String}
   * @param callback {function}
   */
  putCache: function putCache(_ref, callback) {
    var _this = this;

    var type = _ref.type,
        key = _ref.key,
        value = _ref.value;
    // 18
    if (!type || typeof key !== 'string') {
      return;
    }

    return sdk.then(function (platform) {
      platform.invoke((0, _tools.wrapperNativeName)('putCache'), { type: type, key: key, value: value }, (0, _tools.safeFunction)(callback));
    }).catch(function (e) {
      if (_this.debug) {
        console.log(type, 'storage is full.');
      }
    });
  },


  /**
   * 从本地缓冲区获取数据,可以一次取多个key,以spliter分割,默认为';'
   * @param type {String} local|session
   * @param key {String}
   * @returns {{}} json
   * @param callback {function}
   */
  getCache: function getCache(_ref2, callback) {
    var type = _ref2.type,
        key = _ref2.key;
    // 19
    if (!type || typeof key !== 'string') {
      return;
    }
    return sdk.then(function (platform) {
      platform.invoke((0, _tools.wrapperNativeName)('getCache'), { type: type, key: key }, callback);
    });
  },


  /**
   * 从缓冲区移除数据,可以一次删除多个key,以spliter分割,默认为';'
   * @param type {String} local|session
   * @param key {String}
   * @param callback {function}
   */
  removeCache: function removeCache(_ref3, callback) {
    var type = _ref3.type,
        key = _ref3.key;
    // 20
    if (!type || typeof key !== 'string') {
      return;
    }
    return sdk.then(function (platform) {
      platform.invoke((0, _tools.wrapperNativeName)('removeCache'), { key: key }, callback);
    });
  },


  /************ 事件监听 **************/
  /**
   * app返回键监听
   * @param callback
   */
  onBackPress: function onBackPress(callback) {
    // 21
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onBackPress')) {
      return sdk.then(function (platform) {
        platform.on((0, _tools.wrapperNativeName)('onBackPress'), {}, (0, _tools.safeFunction)(callback));
      });
    }
  },

  /**
   * webview关闭监听
   * @param callback
   */
  onClose: function onClose(callback) {
    // 22
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onClose')) {

      return sdk.then(function (platform) {
        platform.on((0, _tools.wrapperNativeName)('onClose'), {}, (0, _tools.safeFunction)(callback));
      });
    }
  },

  /**
   * 当前用户被登出监听
   * @param callback
   */
  onLogout: function onLogout(callback) {
    // 23
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onLogout')) {

      return sdk.then(function (platform) {
        platform.on((0, _tools.wrapperNativeName)('onLogout'), {}, (0, _tools.safeFunction)(callback));
      });
    }
  },

  /**
   * 设备网络情况监听
   * @param callback
   */
  onNetChanged: function onNetChanged(callback) {
    // 24
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onNetChanged')) {
      return sdk.then(function (platform) {
        platform.on((0, _tools.wrapperNativeName)('onNetChanged'), {}, function (resp) {
          if (resp && resp.code === 0 && resp.data) {
            resp.data.hasNetwork = Boolean(resp.data.hasNetwork);
          }
          callback(resp);
        });
      });
    }
  },

  /**
   * webview切到后台监听
   * @param callback
   */
  onBackground: function onBackground(callback) {
    // 25
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onBackground')) {
      return sdk.then(function (platform) {
        platform.on((0, _tools.wrapperNativeName)('onBackground'), {}, callback);
      });
    }
  },

  /**
   * webview回到前台监听
   * 只有先触发onBackground才能触发onForeground
   * @param callback
   */
  onForeground: function onForeground(callback) {
    // 26
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onForeground')) {
      return sdk.then(function (platform) {
        platform.on((0, _tools.wrapperNativeName)('onForeground'), {}, callback);
      });
    }
  },

  /**
   * 设备摇一摇监听
   * @param callback
   */
  onShake: function onShake(callback) {
    // 27
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onShake')) {
      return sdk.then(function (platform) {
        platform.on((0, _tools.wrapperNativeName)('onShake'), {}, callback);
      });
    }
  },

  /**
   * app推送消息监听
   * @param busisessType 指定监听的业务类型
   * @param callback
   */
  onPush: function onPush(busisessType, callback) {
    // 28
    if ((0, _tools.required)(this.debug, {
      busisessType: busisessType,
      callback: callback
    }, 'onPush')) {

      return sdk.then(function (platform) {
        platform.on((0, _tools.wrapperNativeName)('onPush'), { busisessType: busisessType }, callback);
      });
    }
  },


  // 以下为直销银行App额外方法

  /**
   * 获取 App 公共参数信息
   * @param callback {function}
   * 返回的数据格式为
   * 注意：data 中的值是字符串 json 数据，需要使用 JSON.parse(data) 解析处理
   *
   {
    code: 0,
    time: 1505199918343,
    data: {
      appVersion: 'app 版本',
      auth: '753b72ef82faa1ca96a9137bfcf5dbd0',
      channel: '渠道标识',
      clientName: '设备（ios，android',
      custId: '101353543487838019584',
      deviceId: '设备唯一标识',
      deviceType: '设备类型',
      deviceName: '设备名称',
      mac: 'mac地址'
    }
   }
   */
  getAppCommonInfo: function getAppCommonInfo(callback) {
    // 29
    if ((0, _tools.required)(this.debug, { callback: callback }, 'getAppCommonInfo')) {
      return sdk.then(function (platform) {
        platform.invoke((0, _tools.wrapperNativeName)('getAppCommonInfo'), {}, (0, _tools.safeFunction)(callback));
      });
    }
  },


  /**
   * 自定义的非标准SaaS服务的网络请求
   * @param param {{}}
   * param 格式
   {
    url: '请求url地址',
    httpMethod: 'GET 或 POST DELETE 等', // 注意是大写
    parameters: 'json 字符串' // JSON.stringify(json)
   }
   * @param callback {function}
   */
  appRequest: function appRequest(param, callback) {
    // 30
    if ((0, _tools.required)(this.debug, {
      param: param,
      'param.url': param && param.url,
      'param.httpMethod': param && param.httpMethod,
      'param.parameters': param && param.parameters,
      callback: callback
    }, 'request')) {

      return sdk.then(function (platform) {
        platform.invoke((0, _tools.wrapperNativeName)('request'), param, (0, _tools.safeFunction)(callback));
      });
    }
  },


  /**
   * 调用密码键盘
   * 调起交易密码输入框（专供App使用）
   * @param callback {function}
   * * 返回的数据格式为
   *
   {
    code: 0,
    time: 1505199918343,
    data: {
      timeString: '',
      password: '加密后的密码'
    }
   }
   */
  showTradePasswordInput: function showTradePasswordInput(callback) {
    // 31
    if ((0, _tools.required)(this.debug, { callback: callback }, 'showTradePasswordInput')) {
      return sdk.then(function (platform) {
        platform.invoke((0, _tools.wrapperNativeName)('showTradePasswordInput'), {}, (0, _tools.safeFunction)(callback));
      });
    }
  },


  /**
   * 登录超时或者单点登录 auth 失效
   */
  authOutOfDate: function authOutOfDate() {
    // 32
    return sdk.then(function (platform) {
      platform.invoke((0, _tools.wrapperNativeName)('authOutOfDate'), {});
    });
  },


  /**
   * 弹出ResultControl对话框
   * @param callback {function}
   */
  showResultCtrlDialog: function showResultCtrlDialog(callback) {
    // 33
    if ((0, _tools.required)(this.debug, { callback: callback }, 'showResultCtrlDialog')) {
      return sdk.then(function (platform) {
        platform.invoke((0, _tools.wrapperNativeName)('showResultCtrlDialog'), (0, _tools.safeFunction)(callback));
      });
    }
  }
};

exports.default = appSdk;
/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(process) {

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sdk = undefined;

var _tools = __webpack_require__(1);

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var doc = document;

// 用 Promise 包裹 sdk
var sdk = exports.sdk = new Promise(function (resolve, reject) {
  resolve();
});

// 不在 app 中，使用这里定义的处理
var appSdk = {
  debug: process.env.NODE_ENV === 'development', // 是否启用调试,再调试模式下参数检查情况会输出到控制台

  /**
   * 设置
   * @param debug
   */
  setDebug: function setDebug(debug) {
    this.debug = debug;
  },


  /*eslint-disable max-len*/
  /**
   * 获取platform协议的实现情况，比如可用的事件、可用的接口、协议版本等
   * @param callback
   * 返回的结果
   {
      code: 0,
      data: '*appRequest*authOutOfDate*buryEvent*buryPageEnd*buryPageStart*checkLoginStatus*checkNetwork*close*confirm*getAppCommonInfo*getCache*getCommonInfo*getPayLimit*onEvent*putCache*removeCache*request*setMenu*setTitle*setTitleBarVisible*showResultCtrlDialog*showTradePasswordInput*toast',
      time: '1505728066354'
    }
   */
  env: function env(callback) {
    // 1
    return sdk.then(function () {
      console.info('获取platform协议的实现情况,可用的事件、可用的接口、协议版本');
      /*eslint-disable max-len*/
      callback({
        code: 0,
        data: '*appRequest*authOutOfDate*buryEvent*buryPageEnd*buryPageStart*checkLoginStatus*checkNetwork*close*confirm*getAppCommonInfo*getCache*getCommonInfo*getPayLimit*onEvent*putCache*removeCache*request*setMenu*setTitle*setTitleBarVisible*showResultCtrlDialog*showTradePasswordInput*toast',
        time: '1505728066354'
      });
    });
  },


  /**
   * 设置 title
   * @param titleName
   */
  setTitle: function setTitle(param) {
    // 2
    if ((0, _tools.required)(this.debug, {
      param: param
    }, 'setTitle')) {

      return sdk.then(function () {
        console.info('设置浏览器标题');
        document.title = param.titleName;
        var i = document.createElement('iframe');
        i.src = '/favicon.ico';
        i.style.display = 'none';
        i.onload = function () {
          setTimeout(function () {
            i.remove();
          }, 9);
        };
        document.body.appendChild(i);
      });
    }
  },


  /**
   * 设置标题栏的显示/隐藏
   * @param visible {boolean}
   */
  setTitleBarVisible: function setTitleBarVisible() {
    var visible = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    // 3
    return sdk.then(function () {
      console.info('设置标题栏的显示/隐藏');
    });
  },


  /**
   * 设置当前页面头部右侧菜单
   * 单个直接显示在右侧，多个的话以下拉的形式显示
   * 目前实现：Android 当路由切换后会自动去掉右侧菜单
   * 但 IOS 需要手动清除掉右侧菜单，传入空数组即可
   * @param menus {Array}
   * 参数格式
   [{
      menuTitle: "扫一扫",
      menuImage: "http://localhost:8080/sao.png",
      menuAction: "function"
   }]
   *
   */
  setMenu: function setMenu() {
    var menus = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    // 4
    if (!Array.isArray(menus)) {
      if (this.debug) {
        console.log('setMenu, menus 必须是一个数组类型');
      }
      return;
    }
    for (var l = menus.length; l > 0; l--) {
      var _required;

      var _menu = menus[l - 1];
      if (!(0, _tools.required)(this.debug, (_required = {}, _defineProperty(_required, 'menus[' + l + '].menuTitle', _menu.menuTitle), _defineProperty(_required, 'menus[' + l + '].menuAction', _menu.menuAction), _required), 'setMenu')) {
        return;
      }
    }

    menus.forEach(function (it) {
      it.menuAction = (0, _tools.safeFunction)(it.menuAction);
    });

    return sdk.then(function () {
      if (!menus || menus.length === 0) {
        var menusEl = doc.getElementById('app-sdk-menu');
        doc.documentElement.removeChild(menusEl);
      } else {
        var menuEl = doc.createElement('div');
        menuEl.id = 'app-sdk-menu';
        menuEl.style.position = 'absolute';
        menuEl.style.top = '10px';
        menuEl.style.right = '10px';

        menus.forEach(function (it) {
          var subMenuEl = doc.createElement('a');
          subMenuEl.href = '#';
          subMenuEl.innerHTML = it.menuTitle;
          subMenuEl.addEventListener('click', function (e) {
            e.preventDefault();
            it.menuAction();
          }, false);
          menuEl.appendChild(subMenuEl);
        });
        doc.documentElement.appendChild(menuEl);
      }
      console.info('设置菜单');
    });
  },


  /**
   * 获取公共参数信息
   * @param callback {function}
   * 返回的数据格式为
   *
   {
    code: 0,
    time: 1505199918343,
    data: {
      appVersion: 'app 版本',
      channel: '渠道标识',
      clientName: '设备（ios，android',
      deviceId: '设备唯一标识',
      deviceType: '设备类型',
      mac: 'mac地址',
      osVersion: ''
    }
   }
   */
  getCommonInfo: function getCommonInfo(callback) {
    // 5
    if ((0, _tools.required)(this.debug, { callback: callback }, 'getCommonInfo')) {
      return sdk.then(function () {
        callback({
          code: 0,
          time: 1505199918343,
          data: {
            appVersion: 'app 版本',
            channel: '渠道标识',
            clientName: '设备（ios，android',
            deviceId: '设备唯一标识',
            deviceType: '设备类型',
            mac: 'mac地址',
            osVersion: ''
          }
        });
      });
    }
  },


  /**
   * 获取当前用户的基本信息
   * @param callback {function}
   * 返回的数据格式为
   *
   {
    code: 0,
    time: 1505199918343,
    data: {
      channelUserId: '渠道用户标识',
      hasOpenSecAccount: '是否已开通二类户'
    }
   }
   */
  getUserInfo: function getUserInfo(callback) {
    // 6
    if ((0, _tools.required)(this.debug, { callback: callback }, 'getUserInfo')) {
      return sdk.then(function () {
        callback({
          code: 0,
          time: 1505199918343,
          data: {
            channelUserId: '渠道用户标识',
            hasOpenSecAccount: '是否已开通二类户'
          }
        });
      });
    }
  },


  /**
   * 网络请求
   * @param param {{}}
   * param 格式
   {
    url: '请求url地址',
    httpMethod: 'GET 或 POST DELETE 等', // 注意是大写
    parameters: 'json 字符串' // JSON.stringify(json)
   }
   * @param callback {function}
   */
  request: function request(param, callback) {
    // 7
    if ((0, _tools.required)(this.debug, {
      param: param,
      'param.url': param && param.url,
      'param.httpMethod': param && param.httpMethod,
      'param.parameters': param && param.parameters,
      callback: callback
    }, 'request')) {

      return sdk.then(function () {
        console.info('网络请求');
      });
    }
  },


  /**
   * 弹出toast
   * @param param {{}} { msg(必填):String }
   */
  toast: function toast(param) {
    // 8
    if ((0, _tools.required)(this.debug, { param: param, 'param.msg': param && param.msg }, 'toast')) {
      return sdk.then(function () {
        console.info('弹出toast');
        // 这里可以走 h5 toast
      });
    }
  },


  /**
   * 确认提示框
   * @param param {{}} { title(必填):String, msg(必填):String, cancelBtnText:String, cancelCallBack:function, okBtnText:String, okCallBack:function }
   */
  confirm: function confirm(param) {
    // 9
    if ((0, _tools.required)(this.debug, {
      param: param,
      'param.title': param && param.title,
      'param.msg': param && param.msg
    }, 'confirm')) {

      return sdk.then(function () {
        console.info('弹出简单对话框');
      });
    }
  },


  /**
   * 关闭浏览器
   */
  close: function close() {
    // 10
    return sdk.then(function () {
      console.info('关闭浏览器');
    });
  },


  /**
   * 启动app模块，目前实现的模块有：登录：LOGIN（如果当前是登录态，则不会跳到登录页面，只会回调 callback）开户：OPENACCOUNT
   * @param param {{}}
   * @param callback {function}
   * 回调结果根据具体的模块返回不同的数据
   * name是LOGIN的情况下：返回值和 getUserInfo 返回值相同
   */
  start: function start(param, callback) {
    // 11
    if ((0, _tools.required)(this.debug, {
      param: param,
      'param.name': param && param.name,
      'param.param': param && param.param
    }, 'start')) {

      param.param = JSON.stringify(param.param);

      return sdk.then(function () {
        console.info('启动app模块');
      });
    }
  },


  /**
   * 检查设备的网络状况
   *
   * @param callback {function} 回调参数 : { hasNetwork:boolean, netType:String(wifi|2G|3G|4G|unknow) }
   */
  checkNetwork: function checkNetwork(callback) {
    // 12
    if ((0, _tools.required)(this.debug, { callback: callback }, 'checkNetwork')) {

      return sdk.then(function () {
        console.info('检查设备的网络状况');
        callback();
      });
    }
  },


  /**
   * 调用app的分享功能
   * @param param {{}} { type(必填): String[text|web|view], channel(必填): String[WX|QQ|WB|MON|STOCK] }
   * * 参数格式
   {
      channel: 'WX|WB|QQ|MON|STOCK', // 分享渠道， WX|WB|QQ|MON|STOCK 中间用竖线隔开，可选其中某个或某几个， 空串的话默认为全部。WX代表微信好友和微信朋友圈
      url: '', // Web分享地址
      title: '', //  Web分享标题
      desc: '', //  Web分享描述
      text: '', //  文本分享内容
      iconUrl: '', //  Web分享图标
      startY: '', //  截图起始 0-1的值 页面比例
      endY: '', //  截图尾部 0-1的值 页面比例
      type: '', // 分享类型（text, view, web）(类型为text时，text必填类型，为view时，startY和endY必填类型，为web时，url必填)
   }
    * @param callback {function}
   */
  share: function share(param, callback) {
    // 13
    if ((0, _tools.required)(this.debug, {
      param: param,
      'param.type': param && param.type,
      'param.channel': param && param.channel
    }, 'share')) {

      if (['text', 'web', 'view'].indexOf(param.type) === -1) {
        if (this.debug) {
          console.log('不正确的分享类型:', param.type);
        }
        return;
      }

      var channels = param.channel.split('|'),
          expectChannel = ['WX', 'QQ', 'WB', 'MON', 'STOCK'];
      for (var l = channels.length; l > 0; l--) {
        if (expectChannel.indexOf(channels[l - 1]) === -1) {
          if (this.debug) {
            console.log('不正确的分享渠道:', param.channel);
          }
          return;
        }
      }

      return sdk.then(function () {
        console.info('调用app的分享功能');
        callback();
      });
    }
  },


  /**
   * 进入页面埋点
   * @param param {page: 'page1'} 页面名称 (同一页面的页面名称应和 buryPageEnd 中的页面名称相同
   * @returns {Promise.<TResult>}
   */
  buryPageStart: function buryPageStart(param) {
    // 14
    if ((0, _tools.required)(this.debug, {
      param: param
    }, 'buryPageStart')) {

      return sdk.then(function () {
        console.info('');
      });
    }
  },


  /**
   * 离开页面埋点
   * @param param {page: 'page1'} 页面名称 (同一页面的页面名称应和 buryPageStart 中的页面名称相同
   * @returns {Promise.<TResult>}
   */
  buryPageEnd: function buryPageEnd(param) {
    // 15
    if ((0, _tools.required)(this.debug, {
      param: param
    }, 'buryPageEnd')) {

      return sdk.then(function () {
        console.info('');
      });
    }
  },


  /**
   * 埋点事件
   * @param param {}
   * 传参格式
   {
     eventID: '', //事件ID
     properties: {} // 事件属性
   }
   * @returns {Promise.<TResult>}
   */
  buryEvent: function buryEvent(param) {
    // 16
    if ((0, _tools.required)(this.debug, {
      param: param
    }, 'buryEvent')) {

      return sdk.then(function () {
        console.info('');
      });
    }
  },


  /**
   * 检查是否是登录状态
   * @param callback
   * 返回结果
   {
     code: 0,
     data: {
      isLogin: true // 是否为登录态
     },
     time: ''
   }
   * @returns {Promise.<TResult>}
   */
  checkLoginStatus: function checkLoginStatus(callback) {
    // 17
    return sdk.then(function () {
      console.info('检查是否是登录状态');
    });
  },


  /**
   * 放入本地缓存,考虑缓冲区已满的问题
   * @param {string} type local|session
   * @param key {String}
   * @param value {String}
   * @param callback {function}
   */
  putCache: function putCache(type, key, value, callback) {
    var _this = this;

    // 18
    if (!type || typeof key !== 'string') {
      return;
    }

    return sdk.then(function () {
      console.info('放入本地缓存,考虑缓冲区已满的问题');
      callback();
    }).catch(function (e) {
      if (_this.debug) {
        console.log(type, 'storage is full.');
      }
    });
  },


  /**
   * 从本地缓冲区获取数据,可以一次取多个key,以spliter分割,默认为';'
   * @param type {String} local|session
   * @param key {String}
   * @returns {{}} json
   * @param callback {function}
   */
  getCache: function getCache(type, key, callback) {
    // 19
    if (!type || typeof key !== 'string') {
      return;
    }
    return sdk.then(function () {
      console.info('从本地缓冲区获取数据,可以一次取多个key,以spliter分割,默认为\';\'');
      callback();
    });
  },


  /**
   * 从缓冲区移除数据,可以一次删除多个key,以spliter分割,默认为';'
   * @param type {String} local|session
   * @param key {String}
   * @param callback {function}
   */
  removeCache: function removeCache(type, key, callback) {
    // 20
    if (!type || typeof key !== 'string') {
      return;
    }
    return sdk.then(function () {
      console.info('从缓冲区移除数据,可以一次删除多个key,以spliter分割,默认为\';\'');
      callback();
    });
  },


  /************ 事件监听 **************/
  /**
   * app返回键监听
   * @param callback
   */
  onBackPress: function onBackPress(callback) {
    // 21
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onBackPress')) {
      return sdk.then(function () {
        console.info('app返回键监听');
        callback();
      });
    }
  },

  /**
   * webview关闭监听
   * @param callback
   */
  onClose: function onClose(callback) {
    // 22
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onClose')) {

      return sdk.then(function () {
        console.info('webview关闭监听');
        callback();
      });
    }
  },

  /**
   * 当前用户被登出监听
   * @param callback
   */
  onLogout: function onLogout(callback) {
    // 23
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onLogout')) {

      return sdk.then(function () {
        console.info('当前用户被登出监听');
        callback();
      });
    }
  },

  /**
   * 设备网络情况监听
   * @param callback
   */
  onNetChanged: function onNetChanged(callback) {
    // 24
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onNetChanged')) {
      return sdk.then(function () {
        console.info('设备网络情况监听');
        callback();
      });
    }
  },

  /**
   * webview切到后台监听
   * @param callback
   */
  onBackground: function onBackground(callback) {
    // 25
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onBackground')) {
      return sdk.then(function () {
        console.info('webview切到后台监听');
        callback();
      });
    }
  },

  /**
   * webview回到前台监听
   * 只有先触发onBackground才能触发onForeground
   * @param callback
   */
  onForeground: function onForeground(callback) {
    // 26
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onForeground')) {
      return sdk.then(function () {
        console.info('webview回到前台监听');
        callback();
      });
    }
  },

  /**
   * 设备摇一摇监听
   * @param callback
   */
  onShake: function onShake(callback) {
    // 27
    if ((0, _tools.required)(this.debug, {
      callback: callback
    }, 'onShake')) {
      return sdk.then(function () {
        console.info('设备摇一摇监听');
        callback();
      });
    }
  },

  /**
   * app推送消息监听
   * @param busisessType 指定监听的业务类型
   * @param callback
   */
  onPush: function onPush(busisessType, callback) {
    // 28
    if ((0, _tools.required)(this.debug, {
      busisessType: busisessType,
      callback: callback
    }, 'onPush')) {

      return sdk.then(function () {
        console.info('app推送消息监听');
        callback();
      });
    }
  },


  // 直销银行App额外方法

  /**
   * 获取 App 公共参数信息
   * @param callback {function}
   * 返回的数据格式为
   *
   {
    code: 0,
    time: 1505199918343,
    data: {
      appVersion: 'app 版本',
      auth: '753b72ef82faa1ca96a9137bfcf5dbd0',
      channel: '渠道标识',
      clientName: '设备（ios，android',
      custId: '101353543487838019584',
      deviceId: '设备唯一标识',
      deviceType: '设备类型',
      deviceName: '设备名称',
      mac: 'mac地址'
    }
   }
   */
  getAppCommonInfo: function getAppCommonInfo(callback) {
    // 29
    if ((0, _tools.required)(this.debug, { callback: callback }, 'getAppCommonInfo')) {
      return sdk.then(function () {
        callback();
      });
    }
  },


  /**
   * 自定义的非标准SaaS服务的网络请求
   * @param param {{}}
   * param 格式
   {
    url: '请求url地址',
    httpMethod: 'GET 或 POST DELETE 等', // 注意是大写
    parameters: 'json 字符串' // JSON.stringify(json)
   }
   * @param callback {function}
   */
  appRequest: function appRequest(param, callback) {
    // 30
    if ((0, _tools.required)(this.debug, {
      param: param,
      'param.url': param && param.url,
      'param.httpMethod': param && param.httpMethod,
      'param.parameters': param && param.parameters,
      callback: callback
    }, 'request')) {

      return sdk.then(function () {
        console.info('自定义的非标准SaaS服务的网络请求');
      });
    }
  },


  /**
   * 调用密码键盘
   * @param callback {function}
   * * 返回的数据格式为
   *
   {
    code: 0,
    time: 1505199918343,
    data: {
      timeString: '',
      password: '加密后的密码'
    }
   }
   */
  showTradePasswordInput: function showTradePasswordInput(callback) {
    // 31
    if ((0, _tools.required)(this.debug, { callback: callback }, 'showTradePasswordInput')) {
      return sdk.then(function () {
        console.info('调用密码键盘');
      });
    }
  },


  /**
   * 登录超时或者单点登录 auth 失效
   */
  authOutOfDate: function authOutOfDate() {
    // 32
    return sdk.then(function () {
      console.info('登录超时或者单点登录 auth 失效');
    });
  },


  /**
   * 弹出ResultControl对话框
   * @param callback {function}
   */
  showResultCtrlDialog: function showResultCtrlDialog(callback) {
    // 33
    if ((0, _tools.required)(this.debug, { callback: callback }, 'showResultCtrlDialog')) {
      return sdk.then(function () {
        console.info('弹出ResultControl对话框');
      });
    }
  }
};

exports.default = appSdk;
/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(0)))

/***/ })
/******/ ]);
});
//# sourceMappingURL=app-sdk.js.map