'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var win = window;
var ua = win.navigator.userAgent;

// 各种设备判断，后续根据需要再加入
var isWx = exports.isWx = ua.search(/micromessenger/ig) !== -1; // 微信
var isIos = exports.isIos = ua.indexOf('iPhone') !== -1 || ua.indexOf('iPad') !== -1; // ios 系统
var isAndroid = exports.isAndroid = ua.indexOf('Android') !== -1; // Android 系统
var isJdApp = exports.isJdApp = ua.indexOf('jdapp') !== -1; // 京东 app
var isDlApp = exports.isDlApp = /zxyh_dalianbank/i.test(ua); // 大连银行
var isZxyh = exports.isZxyh = /zxyh/i.test(ua); // 直销银行银行
// TODO 我们用 isZxyh 来判断是在 app 中，后续根据需要增加判断条件
var isApp = exports.isApp = isZxyh;
var isMobile = exports.isMobile = isIos || isAndroid; // 手机端
var isPc = exports.isPc = !isMobile; // pc 端